/////////////////////////////////////////////////////////////////////////
//Nichtlineares dynamisches System: Standard-Map periodisch/chaotisch
//y-Schnitt durch Standard-Map mit Lyapunov-Koeffizient ähnlichem Verfahren
/////////////////////////////////////////////////////////////////////////
//Durch die Verwendung von double Attributen kann problemlos 10 000 000 fach vergrößert werden!
//////////////////////////////////////////////////////////////////////////////////////////
//Bildausschnitt zu Beginn:
double xU = 0; double xO = 1;
double yU = 0; double yO = 1;

//Zwischenspeicher:
double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
double xAlt, yAlt, xNeu, yNeu, xH, yH; //Parameter für Iteration Punkt 1
double xAlt1,yAlt1,xNeu1,yNeu1,xH1, yH1; //Parameter für Iteration Punkt 2
boolean zeichnen;
int n, i;//Anzahl Punkte pro Iteration
int xK, yK;//Koordinaten der Punkte
int l, L;//Für Anzahl an Startpunkten
int farbe,saettigung,helligkeit;//für Farbe, Sättigung und Helligkeit
String s;
double K;
double D = 0.000005;//auch noch kleiner möglich bei double
double abstand;
double aK ; // Abstand in y-Koordinaten
int aNull;
double delta;//Schritt zum nächsten x- bzw y-Wert
int Z; //ab Z wird gezeichnet
double lambda;
double lambdaKNeu, lambdaKAlt;
int LVerschiebung = 200;
double faktorAbstandKlein;
double faktorAbstandGross;
double faktorLambda;
int j =0;
int vergroesserungsFaktor =1;
double abstandLog =1;

//Initialisierungen  
void setup(){ 
  size(800,800);
  background(0); 
  //K = 0.2;
  //K = 1.5; //alternativer K-Wert
  K=0.971635;//Parameter der Tschirikow-Tayler-Standardabbildung 
  xK=0;//von 0 bis w-1
  
  n= 5000; i=0;   //n...Anzahl der Iterationen - optimaler Bereich  1000 <= n <= 100000 
  Z = 1;// Ab Z wird der Abstand der beiden Punkte berechnet und im Schaubild eingetragen
  faktorAbstandKlein = 40/(float)n;//um lkleiner Abstandwerte sehen zu können
  faktorAbstandGross = 0.1/(float)n;//um größere Abstandswert in das Fenster einzupassen
  faktorLambda = 50*n;
  delta = (yO-yU)/height;
  xH = 0.5; //Hier können Werte von 0 bis 1 gewählt werden, um weitere Schnitte zu sehen
  yH = yU;
  xUNeu = 0; xONeu = 0;
  yUNeu = 0; yUNeu = 0;
  abstand =0; 
  lambda =0;
  lambdaKNeu =0;
  lambdaKAlt =0;
  strokeWeight(1); 
  zeichnen = true;
}
/////////////////////////////////////////////////////////////////////// 
 void draw(){  

 if (zeichnen){  
     iteriere(xH,yH,n); 
       yH = yH +delta;
     l++; 
     if(l>=height){
      println("Fertig! "+width+" Schritte und "+n+" Punkte pro Iteration verwendet."); 
     
      zeichnen = false; 
     }
     if( Math.abs((double)xH) >=100) {
      println("fertig durch Grenze  "+l); zeichnen = false; 
     }   
 }
}

//////////////////////////////////////////////////////////
//Eine erste Iteration wird im setup() ausgelöst
////////////////////////////////////////////////////////
void iteriere(double xH, double yH, int N){  
  colorMode(HSB,256,256,256);
  lambda = 0;
   xK++;
   i=0;
   j=0;
   xAlt = xH; xAlt1 = xH ;
   yAlt = yH; yAlt1 = yH + D ;//Abweichung D
  this.n =   N;
 
  while(i < n){ 
    
     yNeu = yAlt + K*Math.sin(2*Math.PI*xAlt)/(2*Math.PI);//  Modulo 1 verzerrt die Abstandsmessung und wird daher weggelassen
     xNeu = xAlt + yNeu;  
       
     yNeu1 = (yAlt1 + K*Math.sin(2*Math.PI*xAlt1)/(2*Math.PI));//   Modulo 1 verzerrt die Abstandsmessung und wird daher weggelassen
     xNeu1 = (xAlt1 + yNeu1);      
    
     if(i >= Z ){ //ab Z werden die einzelnen Abstände senkrecht über dem zugehörigen x-Wert farblich eingetragen.
       abstand = Math.sqrt((xNeu-xNeu1)*(xNeu-xNeu1)+(yNeu-yNeu1)*(yNeu-yNeu1))/D;//relativer Abstand bei Iteration i    
       abstandLog = Math.log(abstand); 
       if(abstand*faktorAbstandKlein <= LVerschiebung//Lambda-Schaubild noch oben verschieben
       )//größerer Faktor, damit auch kleine Werte für den Abstand sichtbar werden (transparent gezeichnet)
         //Die Punkte werden vielfach überschrieben, daher Transparenz sehr klein
           { aK =(height-abstand*faktorAbstandKlein); farbe = 0; saettigung=10;
             helligkeit = 220-(int)(abstand*faktorAbstandKlein); //Werte mit diesem Maßstab werden grau             
           }                                                     // wird nach oben dunkler werdend ausgeblendet
         else {aK =(height-abstand*faktorAbstandGross);farbe = (int)(aK/3) % 255; 
               if(farbe<0) farbe = farbe+256; saettigung= 255; helligkeit = 255;
             }    
       stroke(farbe,saettigung,helligkeit);        
       point(xK,(float)aK);//Abstände ab Z für jedes yK (farbig)
      
       if(i==n-1)//Nur der letzte Wert wird zur Berechnung von lambda herangezogen
       lambda = Math.log(Math.abs(abstandLog))/n;
     } 
     xAlt  = xNeu;
     yAlt  = yNeu; 
     xAlt1 = xNeu1;
     yAlt1 = yNeu1; 
     i++; 
  }
   i=0; 
  
   lambdaKNeu = height-faktorLambda*lambda;
   stroke(255); strokeWeight(1);
   if(xK >1)//Für xK =0  kein Wert für lambdaKAlt errechnet)    
     line((float)(xK-1),(float)(lambdaKAlt-LVerschiebung),(float)xK,(float)(lambdaKNeu-LVerschiebung)); 
   strokeWeight(1);
   point(xK,height-LVerschiebung);// Ly Null-Linie
   lambdaKAlt = lambdaKNeu;
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 5-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() { 
  
  println("x = "+ mouseX +"  y = "+mouseY);//Info
  
  if (mouseButton == RIGHT){
      background(0);
      l=0;
      xK=0; 
      j=0;
      vergroesserungsFaktor =vergroesserungsFaktor *5;
      n= n+1000;
      yUNeu = map(mouseX,0,width,(float)yU,(float)yO)-(yO-yU)/10;
      yONeu = map(mouseX,0,width,(float)yU,(float)yO)+(yO-yU)/10; 
      yU =yUNeu; yO = yONeu; 
      yH = yU;
      delta = (yO-yU)/height;//anpassen der Schrittweite
      zeichnen = true; 
      println("xMin = "+yU+" xMax = "+yO+" Vergrößerungsfakor = "+vergroesserungsFaktor);
       }
}
///////////////////////////////////////////////////////////
void keyPressed() {
  if (key == '+'){//Störungsfaktor K um 0.1  vergrößern
     background(0);
     yH = yU;
     l=0;
     xK=0;    
     K = K+0.1;
     zeichnen = true; 
     println("K = "+K);
  } 
  if (key == '-'){//Störungsfaktor K um 0.1  verkleinern
     background(0);
     yH = yU;
     l=0;
     xK=0;    
     K = K-0.1;
     zeichnen = true; 
     println("K = "+K);
  } 
    if (key == 'p'){//y-Schnitt an der Stelle yH um 0.02 vergrößern
      background(0);
      xH = xH + 0.02;
      yH = yU ;
      l=0;
      xK=0;    
      zeichnen = true; 
      println("x-Schnitt an der Stelle yH = "+yH);
  } 
  if (key == 'm'){//y-Schnitt an der Stelle yH um 0.02 verkleinern
      background(0);
      xH = xH - 0.02;
      yH = yU ;
      l=0;
      xK=0;    
      zeichnen = true; 
      println("x-Schnitt an der Stelle yH = "+yH);
  } 
   if (key == '1'){//Anzahl der Iterationen n um 1000  vergrößern
     background(0);
     yH = yU;
     l=0;
     xK=0;    
     n = n+1000;
     faktorLambda = 70*n;
     zeichnen = true; 
     println("Anzahl der Iterationen n = "+n);
  } 
  if (key == '2'){//Anzahl der Iterationen n um 1000  verkleinern
     background(0);
     yH = yU;
     l=0;
     xK=0;    
     n = n-1000;
     //faktorLambda = 70*n;
     zeichnen = true; 
     println("Anzahl der Iterationen n = "+n);
  } 
    
}
